import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.rmi.UnmarshalException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

import javax.management.AttributeNotFoundException;
import javax.management.InstanceNotFoundException;
import javax.management.IntrospectionException;
import javax.management.MBeanAttributeInfo;
import javax.management.MBeanException;
import javax.management.MBeanInfo;
import javax.management.MBeanServerConnection;
import javax.management.MalformedObjectNameException;
import javax.management.ObjectInstance;
import javax.management.ObjectName;
import javax.management.ReflectionException;
import javax.management.RuntimeMBeanException;
import javax.management.RuntimeOperationsException;
import javax.management.openmbean.CompositeDataSupport;
import javax.management.remote.JMXConnector;
import javax.management.remote.JMXConnectorFactory;
import javax.management.remote.JMXServiceURL;


public class JMXdataGet {

	public static void main(String[] args) {
		// ڑɕKvȃp[^
		String username = "";
		String password = "";
		String host = "localhost";
		String port = "10101";

		int getInterval = 1000;	// f[^擾Ԋu
		int getCount = -1;		// f[^擾񐔁i-1̏ꍇ͖[vj

		boolean debugMode = false;	// MBeanSĂ\tO

		String separateStr = ",";	// ؂蕶̐ݒ

		/* @NIvV̐ݒ */
		String[] lines;
		for (int i = 0; args.length > i;  i++) {
			if (args[i].matches("^-interval{1}.+")) {
				lines = args[i].split("=");
				getInterval = Integer.parseInt(lines[1]);
			} else if  (args[i].matches("^-count{1}.+")) {
				lines = args[i].split("=");
				getCount = Integer.parseInt(lines[1]);
			} else if  (args[i].equals("-debug")) {
				debugMode = true;
			}
		}
		/* @܂ */

		/* Aݒt@C̓ǂݍ */
		// ڑ̓ǂݍ
		Properties prop = new Properties();
		try {
			prop.load(new FileInputStream("JMXdataGet.properties"));
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		username = prop.getProperty("jmxUser");
		password = prop.getProperty("jmxPassword");
		host = prop.getProperty("host");
		port = prop.getProperty("jmxPort");

		// Ďڂ̓ǂݍ
		LinkedHashMap<String,String> counterMap = new LinkedHashMap<String, String>();
		try {
			FileReader in = new FileReader("counter.conf");
			BufferedReader br = new BufferedReader(in);
			String line;
			while ((line = br.readLine()) != null) {
				String counter[] = line.split("\t");
				counterMap.put(counter[0], counter[1]);
			}
			br.close();
			in.close();
		} catch (IOException e) {
			System.out.println(e);
		}
		/* A܂ */

		try {

		/* BJMXڑ */
			// ڑURL̍쐬
			JMXServiceURL url = new JMXServiceURL("service:jmx:rmi:///jndi/rmi://" + host + ":" + port + "/jmxrmi");

			// ڑ̍쐬
			Map<String, String[]> map = new HashMap<String, String[]>();
			String[] credentials = new String[] { username, password };
			map.put("jmx.remote.credentials", credentials);

			// JMXڑ
			JMXConnector conn = JMXConnectorFactory.connect(url, map);

			// MBeanServerConnection擾
			MBeanServerConnection mbsc = conn.getMBeanServerConnection();
		/* B܂ */

		/* CfobO[h̏ꍇ 擾MBeanSďo */
			if(debugMode){
				//ׂĂMBeanIuWFNg擾
				Set<ObjectInstance> mBeanSet = mbsc.queryMBeans(null, null);
				Iterator<ObjectInstance> mBeanSetIterator = mBeanSet.iterator();

				while (mBeanSetIterator.hasNext()) {
					ObjectInstance objectInstance = (ObjectInstance)mBeanSetIterator.next();
					ObjectName objectName = objectInstance.getObjectName();

					// IuWFNg̏o
					System.out.println(objectName);

					try {
						// IuWFNgMBean擾
						MBeanInfo mbInfo = mbsc.getMBeanInfo(objectName);
						// IuWFNgɑ鑮擾
						MBeanAttributeInfo mbattr[] = mbInfo.getAttributes();

						// ̏擾
						for(int i=0;i<mbattr.length;i++){
							//System.out.println("\t"+mbattr[i]);
							int start = mbattr[i].toString().indexOf("name=") + 5;
							int end  = mbattr[i].toString().indexOf(",",start);
							String attributeName  = mbattr[i].toString().substring(start, end);
							System.out.print("\t"+attributeName +"\t=\t");
							try {
								System.out.println(mbsc.getAttribute(objectName, attributeName ));
							} catch (RuntimeOperationsException e) {
								System.out.println("[*** couldn't get ***]");
							} catch (AttributeNotFoundException e) {
								System.out.println("[*** couldn't get ***]");
							} catch (UnmarshalException e) {
								System.out.println("[*** couldn't get ***]");
							} catch (ReflectionException e) {
								System.out.println("[*** couldn't get ***]");
							}catch (RuntimeMBeanException e) {
								System.out.println("[*** couldn't get ***]");
							}
						}
					} catch (IntrospectionException e) {
						e.printStackTrace();
					}
				}
				System.exit(0);
			}
		/* C܂ */

		/* DĎڂ̏o */
			// wb_[o
			System.out.print("Timestamp");
			for(String key : counterMap.keySet()){
				System.out.print(separateStr+key);
			}
			System.out.println();

			// tH[}bg̐ݒ
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");

			// count̉񐔃[vi-1̏ꍇ͖[vj
			for (int count = 0; getCount == -1 || count < getCount; count++) {

				// ̏o
				System.out.print(sdf.format(new Date()));

				// coutenrMapɓo^ĂĎڕ[v
				for(String key : counterMap.keySet()){
					// ĎڂObjectNameAttributeNameo
					String value[] = counterMap.get(key).split(";");
					try {
						ObjectName objectName = ObjectName.getInstance(value[0]);
						String attributeName = value[1];
						if(value[0].contains("MemoryPool") && value.length==3){ // Heep֌W̏ꍇ
							// Ďڂ̒l擾
							CompositeDataSupport heep = (CompositeDataSupport) mbsc.getAttribute(objectName, attributeName);
							System.out.print(separateStr+heep.get(value[2]));
						}else{
							// Ďڂ̒l̎擾Əo
							System.out.print(separateStr+mbsc.getAttribute(objectName, attributeName));
						}
					} catch (MalformedObjectNameException e) {
						e.printStackTrace();
					} catch (NullPointerException e) {
						e.printStackTrace();
					} catch (AttributeNotFoundException e) {
						e.printStackTrace();
					}
				}
				System.out.println();

				// 擾ԊuԂX[v(msec)
				Thread.sleep(getInterval);
			}
			/* D܂ */

			conn.close();

		} catch (IOException e) {
			e.printStackTrace();
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
		} catch (ReflectionException e) {
			e.printStackTrace();
		} catch (InterruptedException e) {
			e.printStackTrace();
		} catch (MBeanException e) {
			e.printStackTrace();
		}
	}
}